DiagnosticCollector (Java Platform SE 8 )
Keywords: javax.tools.DiagnosticCollector class
Date: 2026-03-29

compact3
javax.tools

## Class DiagnosticCollector<S>

- java.lang.Object
- - javax.tools.DiagnosticCollector<S>

- Type Parameters:
    `S` - the type of source objects used by diagnostics received by this object
  All Implemented Interfaces:
    DiagnosticListener<S>

      public final class DiagnosticCollector<S>
      extends Object
      implements DiagnosticListener<S>

  Provides an easy way to collect diagnostics in a list.
  Since:
    1.6

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DiagnosticCollector()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<Diagnostic<? extends S>>` | `getDiagnostics()` Gets a list view of diagnostics collected by this object.
    `void` | `report(Diagnostic<? extends S> diagnostic)` Invoked when a problem is found.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DiagnosticCollector

          public DiagnosticCollector()

  - ### Method Detail

    - #### report

          public void report(Diagnostic<? extends S> diagnostic)

      Description copied from interface: `DiagnosticListener`
      Invoked when a problem is found.
      Specified by:
        `report` in interface `DiagnosticListener<S>`
      Parameters:
        `diagnostic` - a diagnostic representing the problem that was found

    - #### getDiagnostics

          public List<Diagnostic<? extends S>> getDiagnostics()

      Gets a list view of diagnostics collected by this object.
      Returns:
        a list view of diagnostics

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.